#-------------------------------------------------
#
# Project created by QtCreator 2011-11-09T15:44:23
#
#-------------------------------------------------

TARGET = appHACDDemo
TEMPLATE = app


# Please EDIT these variables before usage:===============================================================
# Wanted Output Folder (the only one that needs to be absolute, and without ~)
HACDDEMO_OUTPUT_FOLDER_ABSOLUTE_PATH = "/home/myUbuntuUserName/Desktop/QtCreator/Bullet/Demos/HACDDemo/Release"
# Root paths
HACDDEMO_ROOT = "./" # This should be "./" in most cases...
# Root Folders:
BULLET_ROOT = "../../"	# If you placed the HACDDemo folder in "BulletRoot/Demos" this folder shuold be "../../"
HACD_SVN_ROOT =  $$BULLET_ROOT/Extras/Hacd    # Please do not use the original HACD library at $$BULLET_ROOT/Extras/HACD (not compatible at the time of writing), but the one from the SVN sourceforge repository.
VHACD_SVN_ROOT = $$BULLET_ROOT/Extras/v-hacd
# Inc Folders:
FREEGLUT_INCLUDE_FOLDER = "./"  # Freeglut is required, but not included
ASSET_IMPORT_LIBRARY_INCLUDE_FOLDER = "./" # Optional (tweakable in "btTriangleMeshEx.h")
# Lib Folders:
BULLET_LIB_FOLDER = $$BULLET_ROOT/lib  # This depends on your configuration. All the Bullet libs should be there (maybe having a wrong version of the HACD library here is not recommended... better rename it in case of problems)
HACD_SVN_LIB_FOLDER =  $$BULLET_ROOT/lib #  This depends on your configuration. Be sure it's the correct HACD SVN version
VHACD_SVN_LIB_FOLDER =  $$BULLET_ROOT/lib #  This depends on your configuration. Be sure it's the correct HACD SVN version
FREEGLUT_LIB_FOLDER = "./"  # Freeglut is required, but not included
ASSET_IMPORT_LIBRARY_LIB_FOLDER = "./" # Optional (tweakable in "btTriangleMeshEx.h")
# Comment it out if you don't have a single hardcoded -lbullet library, but the usual series: -lBulletDynamics -lBulletCollision -lLinearMath ...
CONFIG += useSingleBigBulletLibrary
# Comment out if openMP is not available, but this MUST be consistent with the value set in file "VHACD_Lib.pro"
CONFIG+= useOpenMP
# ========================================================================================================


# This is just for personal reference (I will create a codeblocks cbp file)
!codeblocks {
DESTDIR = $$HACDDEMO_OUTPUT_FOLDER_ABSOLUTE_PATH
}
codeblocks {
DESTDIR = "./Release"
ASSET_IMPORT_LIBRARY_INCLUDE_FOLDER = "../../Extras/Assimp/include/"
ASSET_IMPORT_LIBRARY_LIB_FOLDER = "../../Extras/Assimp/lib/Win32/"
FREEGLUT_INCLUDE_FOLDER = "../../Extras/Freeglut/include/"
FREEGLUT_LIB_FOLDER = "../../Extras/Freeglut/lib/"
}


SOURCES += $$HACDDEMO_ROOT"/OpenGLEx/btCollisionShapeGarbageCollector.cpp"                      \
        $$HACDDEMO_ROOT"/OpenGLEx/btTriangleMeshEx.cpp"                                         \
        $$HACDDEMO_ROOT"/OpenGLEx/GlutDemoApplicationEx.cpp"                                    \
        $$HACDDEMO_ROOT"/OpenGLEx/GlutStuffEx.cpp"                                              \
        $$HACDDEMO_ROOT"/HACDDemo.cpp"                                                          \
        $$HACDDEMO_ROOT"/main.cpp"                                                              \
	$$HACDDEMO_ROOT"/btHACDCompoundShapeParamsLoader.cpp"					\
	$$HACDDEMO_ROOT"/btVHACDCompoundShapeParamsLoader.cpp"

HEADERS  += $$HACDDEMO_ROOT"/OpenGLEx/btCollisionShapeGarbageCollector.h"                       \
            $$HACDDEMO_ROOT"/OpenGLEx/Optionals/btHACDCompoundShape.h"                          \
            $$HACDDEMO_ROOT"/OpenGLEx/Optionals/btVHACDCompoundShape.h"                          \
            $$HACDDEMO_ROOT"/OpenGLEx/btTriangleMeshEx.h"                                       \
            $$HACDDEMO_ROOT"/OpenGLEx/GlutDemoApplicationEx.h"                                  \
            $$HACDDEMO_ROOT"/HACDDemo.h"

INCLUDEPATH += ./                                                                               \
    $$BULLET_ROOT/src                                                                           \
    $$BULLET_ROOT/Demos/OpenGL                                                                  \
    $$BULLET_ROOT/Extras/Serialize                                                              \
    $$HACD_SVN_ROOT/src/HACD_Lib/inc                                                            \
    $$VHACD_SVN_ROOT/src/VHACD_Lib/inc                                                          \
    $$FREEGLUT_INCLUDE_FOLDER                                                                   \
    $$ASSET_IMPORT_LIBRARY_INCLUDE_FOLDER                                                       \
    $$HACDDEMO_ROOT/OpenGLEx                                                                    \
    $$HACDDEMO_ROOT/OpenGLEx/Optionals

LIBS += -L$$HACD_SVN_LIB_FOLDER                                            \
        -L$$VHACD_SVN_LIB_FOLDER                                            \
        -L$$BULLET_LIB_FOLDER                                              \
        -L$$FREEGLUT_LIB_FOLDER                                             \
        -L$$ASSET_IMPORT_LIBRARY_LIB_FOLDER                                 \
    -lHACD                                                                 \
    -lVHACD                                                                \
    -lassimp                                                                \   # Please remove it if unused
    -lglut -lGLU -lGL

useSingleBigBulletLibrary {
    LIBS += -lbullet
}
!useSingleBigBulletLibrary {
    LIBS+= -lBulletWorldImporter -lBulletFileLoader -lOpenGLSupport         \
    -lBulletSoftBody -lBulletDynamics -lBulletCollision -lLinearMath
}


OTHER_FILES += $$HACDDEMO_ROOT"/BunnyMesh.inl"       \
               $$HACDDEMO_ROOT"/TorusMesh.inl"       \
               $$HACDDEMO_ROOT"/README.txt"

useOpenMP {
    # gcc/mingw settings:
    LIBS += -lgomp
    QMAKE_CXXFLAGS += -fopenmp
    # Visual Studio compiler (cl.exe) settings:
    # LIBS += vcomp.lib		    # (can be included in #pragma directive)
    # QMAKE_CXXFLAGS += /openmp	    # Note that usually without this the program still compiles, but with NO SPEEDUP!
}

# TESTED ON UBUNTU_64 ONLY (hope it works on windows too).
# Please remember to copy the folder: "appHACDDemoMeshes" to the directory where your exe is before usage.
# In case of problems maybe using directories without spaces could help.


